# coding: utf-8

"""
    Tripartie

    Our API suite for the **Resolution Center** and the **Safe Checkout** features. Simple, yet elegant web interfaces for your convenience. One request away from your first automated resolution or safe-checkout.  # noqa: E501

    The version of the OpenAPI document: 2.0.0-b2
    Contact: noc@tripartie.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


import re  # noqa: F401

from pydantic import validate_arguments, ValidationError
from typing_extensions import Annotated

from pydantic import Field, StrictBool, StrictInt, StrictStr, conlist

from typing import List, Optional

from tpdk.models.transaction_collection_read import TransactionCollectionRead

from tpdk.api_client import ApiClient
from tpdk.exceptions import (  # noqa: F401
    ApiTypeError,
    ApiValueError
)


class TransactionApi(object):
    """NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient.get_default()
        self.api_client = api_client

    @validate_arguments
    def api_transactions_get_collection(self, page : Annotated[Optional[StrictInt], Field(description="The collection page number")] = None, order_status : Optional[StrictStr] = None, metadata : Annotated[Optional[conlist(conlist(StrictStr))], Field(description="Flattened OrderedMap for metadata. Must be a multiple of two items count. Explicitly set \"null\" for desired value.")] = None, status : Annotated[Optional[StrictStr], Field(description="Filter on a limited subset of status")] = None, exists_dispute : Optional[StrictBool] = None, **kwargs) -> List[TransactionCollectionRead]:  # noqa: E501
        """Retrieves the collection of Transaction resources.  # noqa: E501

        Retrieves the collection of Transaction resources.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.api_transactions_get_collection(page, order_status, metadata, status, exists_dispute, async_req=True)
        >>> result = thread.get()

        :param page: The collection page number
        :type page: int
        :param order_status: 
        :type order_status: str
        :param metadata: Flattened OrderedMap for metadata. Must be a multiple of two items count. Explicitly set \"null\" for desired value.
        :type metadata: List[str]
        :param status: Filter on a limited subset of status
        :type status: str
        :param exists_dispute: 
        :type exists_dispute: bool
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _preload_content: if False, the urllib3.HTTPResponse object will
                                 be returned without reading/decoding response
                                 data. Default is True.
        :type _preload_content: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: List[TransactionCollectionRead]
        """
        kwargs['_return_http_data_only'] = True
        return self.api_transactions_get_collection_with_http_info(page, order_status, metadata, status, exists_dispute, **kwargs)  # noqa: E501

    @validate_arguments
    def api_transactions_get_collection_with_http_info(self, page : Annotated[Optional[StrictInt], Field(description="The collection page number")] = None, order_status : Optional[StrictStr] = None, metadata : Annotated[Optional[conlist(conlist(StrictStr))], Field(description="Flattened OrderedMap for metadata. Must be a multiple of two items count. Explicitly set \"null\" for desired value.")] = None, status : Annotated[Optional[StrictStr], Field(description="Filter on a limited subset of status")] = None, exists_dispute : Optional[StrictBool] = None, **kwargs):  # noqa: E501
        """Retrieves the collection of Transaction resources.  # noqa: E501

        Retrieves the collection of Transaction resources.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.api_transactions_get_collection_with_http_info(page, order_status, metadata, status, exists_dispute, async_req=True)
        >>> result = thread.get()

        :param page: The collection page number
        :type page: int
        :param order_status: 
        :type order_status: str
        :param metadata: Flattened OrderedMap for metadata. Must be a multiple of two items count. Explicitly set \"null\" for desired value.
        :type metadata: List[str]
        :param status: Filter on a limited subset of status
        :type status: str
        :param exists_dispute: 
        :type exists_dispute: bool
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _return_http_data_only: response data without head status code
                                       and headers
        :type _return_http_data_only: bool, optional
        :param _preload_content: if False, the urllib3.HTTPResponse object will
                                 be returned without reading/decoding response
                                 data. Default is True.
        :type _preload_content: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the authentication
                              in the spec for a single request.
        :type _request_auth: dict, optional
        :type _content_type: string, optional: force content-type for the request
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: tuple(List[TransactionCollectionRead], status_code(int), headers(HTTPHeaderDict))
        """

        _params = locals()

        _all_params = [
            'page',
            'order_status',
            'metadata',
            'status',
            'exists_dispute'
        ]
        _all_params.extend(
            [
                'async_req',
                '_return_http_data_only',
                '_preload_content',
                '_request_timeout',
                '_request_auth',
                '_content_type',
                '_headers'
            ]
        )

        # validate the arguments
        for _key, _val in _params['kwargs'].items():
            if _key not in _all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method api_transactions_get_collection" % _key
                )
            _params[_key] = _val
        del _params['kwargs']

        _collection_formats = {}

        # process the path parameters
        _path_params = {}

        # process the query parameters
        _query_params = []
        if _params.get('page') is not None:  # noqa: E501
            _query_params.append(('page', _params['page']))

        if _params.get('order_status') is not None:  # noqa: E501
            _query_params.append(('order[status]', _params['order_status']))

        if _params.get('metadata') is not None:  # noqa: E501
            _query_params.append(('metadata[]', _params['metadata']))
            _collection_formats['metadata[]'] = 'csv'

        if _params.get('status') is not None:  # noqa: E501
            _query_params.append(('status', _params['status']))

        if _params.get('exists_dispute') is not None:  # noqa: E501
            _query_params.append(('exists[dispute]', _params['exists_dispute']))

        # process the header parameters
        _header_params = dict(_params.get('_headers', {}))
        # process the form parameters
        _form_params = []
        _files = {}
        # process the body parameter
        _body_params = None
        # set the HTTP header `Accept`
        _header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # authentication setting
        _auth_settings = ['jwtPersonalKey', 'personaAuthKey', 'oauth']  # noqa: E501

        _response_types_map = {
            '200': "List[TransactionCollectionRead]",
        }

        return self.api_client.call_api(
            '/transactions', 'GET',
            _path_params,
            _query_params,
            _header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            response_types_map=_response_types_map,
            auth_settings=_auth_settings,
            async_req=_params.get('async_req'),
            _return_http_data_only=_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=_params.get('_preload_content', True),
            _request_timeout=_params.get('_request_timeout'),
            collection_formats=_collection_formats,
            _request_auth=_params.get('_request_auth'))
